/********************************************************************
* Filename: SPI.c 													*
* Date: 29/06/2007 													*
* File Version: 1.00 												*
* SPI Funktionen													*
*	-Initalisierung usart1_init()										*
*	-Funktion putch()											*					
* Linker File: p30f6012.gld 										*
* last modified by S.FISCHER 										*
*********************************************************************/


#include "p30f5015.h"
#include "USART.h"
#include "input_capture.h"
#include "ADC.h"
#include "globalvar.h"




void usart1_init (void)
{
	// UTXEN mu nach UARTEN gesetzt werden, ansonsten wird es durch die Harware wieder gelscht
	U1BRG = 15; 			// PLLx16 Baud 115200 bei 30MHZ
	U1MODEbits.PDSEL = 0;	// 8Bit, no parity	
	U1MODEbits.UARTEN = 1;  // USART ein	

	// U1MODEbits.ALTIO = 1;
	// Interrupt Prioritt fr USART1 RX  auf 6 setzen
	// gem Errata zum dsPIC6014 Rev. B1,  IPC2bits.U1RXIP = 6  kann Probleme verursachen		
	asm volatile 
	(
		"push.d w0\n\t"
		"mov #IPC2, w0\n\t"
		"mov #0x0060, w1\n\t"
		"disi #2\n\t"
		"mov w1, IPC2\n\t"
		"mov #IPC2, w0\n\t"
		"pop.d w0"
	);

	U1STAbits.UTXISEL = 0;
	U1STAbits.URXISEL = 0;  // Interrupt, sobald ein Zeichen empfangen worden ist
	U1STAbits.UTXEN = 1;	// enable TX
	IEC0bits.U1RXIE = 1;	// RX Interrupt enable
	IEC0bits.U1TXIE = 1;	// TX Interrupt enable
}



void putch (unsigned char c)
{

	while (U1STAbits.UTXBF);	// Warten, solange Sende Puffer voll ist
	U1TXREG =c;

}



void text_out (unsigned char *buffer)
{
 	
int n;

	for (n=0;buffer[n]!='\0';n++)
			{
						putch(buffer[n]);
			}
	
}

void clear_buffer (unsigned char *buffer)
{
int n; 	
for (n=0;n<20;n++)
		{
			buffer[n]=0;
		}
	
}
	
void tab_out (unsigned char *buffer, int *x ,int *y ,int rows)
{
int i,n;
putch('\f');
//read_analog();
for (i=0;i<rows;i++)
{
		
		//clear_buffer(buffer);
		int_2_ascii(buffer,*x,6);
		for (n=0;n<12;n++)
			{
				putch(buffer[n]);
			}
		clear_buffer(buffer);
		int_2_ascii(buffer,*y,6);
		putch('|');
		for (n=0;n<12;n++)
			{
				putch(buffer[n]);
			}
		putch('\r');	
		putch('\n');
		asm ("CLRWDT");


}
putch('\n');
putch('\n');
putch('\n');
U1STAbits.UTXEN = 0;	// disable TX

}




