/********************************************************************
* Filename: input_capture.c 										*
* Date: 29/06/2007 													*
* File Version: 1.00 												*
* Input Capture mit Timer2 Initalisierung Funktion					*
*	-Initalisierung init_IC()										*
*	-Umwandlung von Counts in Ascii freq int_2_kHz() 				*					
* Linker File: p30f6012.gld 										*
* last modified by S.FISCHER 										*
*********************************************************************/

#include "p30f5015.h"
#include "ADC.h"
#include "globalvar.h"
#include "InCap.h"
void init_IC(void)
{
IC3CON=0x0083; // every rising Edge, TMR2 capture ,intr every event	
//IC1CON=0x00E3; // every rising Edge, TMR2 capture ,intr every 4th event	
IFS1bits.IC3IF=0; // Interruptflag lschen
IEC1bits.IC3IE=1; // Interrupt enablen 
}

void int_2_khz (unsigned char *buffer,long int counts)
{
int b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10;
long int freq;

if (counts==0) counts=1; //Division durch null verhindern

//freq=998200000/((counts+34)*62);
freq=30003000/(counts+5);		//freq=1/((counts+offset_counts)*33ns)


int_2_ascii(buffer,freq,7);
if (freq<10000) //kein 10er also stelle weglassen
{
	buffer[2]=' ';
}
if (freq<100000) //kein 100er also stelle weglassen
{
	buffer[1]=' ';
}
if (freq<1000000) //kein 1000er also stelle weglassen
{
	buffer[0]=' ';
}

buffer[7]=buffer[6];
buffer[6]=buffer[5];
buffer[5]=buffer[4];

	//buffer 4 bis 7 entspricht den 3 nachkommastellen

buffer[4]='.'; //Fliekomma Punkt
buffer[8]='k';
buffer[9]='H';
buffer[10]='z';
buffer[11]='\0';



b0=buffer[0];
b1=buffer[1];
b2=buffer[2];
b3=buffer[3];
b4=buffer[4];
b5=buffer[5];
b6=buffer[6];
b7=buffer[7];
b8=buffer[8];
b9=buffer[9];
b10=buffer[10];
}


//void int_2_strom (unsigned char *buffer,long int counts)
//{
//  		
////T3CON = 0; 						//Turn off Timer1 and clear settings
////TMR3 = 0; 						//Start Timer3 at zero
////PR3 = counts/4; 				//Set period register value for T/4
////T3CON = 0x8000; 				//Turn on Timer3 with 1:1 prescaler
//								// warten bis Timer3 Interrupt dann wird der ADWert eingelesen 				
//while(!IFS0bits.T3IF){} 		//Wait for T3 Interrupt Flag
//read_analog(); 
//int_2_ascii(buffer,ADCBUF0,5);
//LATDbits.LATD0 = 1; 			//Pin RD0 High zum entladen des C's
//LATDbits.LATD0 = 0;				//evtl. warten
//IFS0bits.T3IF=0;			//Timer 3 Interrupt flag rcksetzen
//}

void int_2_khz2 (unsigned char *buffer,long int counts)
{

long int freq;
//long int tper;
//int count_offset=2600;

//if ((counts-count_offset)==0)tper=1;
//tper=500000/(counts-count_offset); //500ms/(Anzahl Flanken - Offset)

//freq=1000000/tper;
freq=counts/0.5;
int_2_ascii(buffer,freq,7);
if (freq<10000) //kein 10er also stelle weglassen
{
	buffer[2]=' ';
}
if (freq<100000) //kein 100er also stelle weglassen
{
	buffer[1]=' ';
}
if (freq<1000000) //kein 1000er also stelle weglassen
{
	buffer[0]=' ';
}

buffer[7]=buffer[6];
buffer[6]=buffer[5];
buffer[5]=buffer[4];

	//buffer 4 bis 7 entspricht den 3 nachkommastellen

buffer[4]='.'; //Fliekomma Punkt
buffer[8]='k';
buffer[9]='H';
buffer[10]='z';
buffer[11]='\0';

}
